# OpenACS Kernel
This package is part of ]project-open[, an open-source enterprise project management system.

For more information about ]project-open[ please see:
* [Documentation Wiki](http://www.project-open.com/en/)
* [V5.0 Download](https://sourceforge.net/projects/project-open/files/project-open/V5.0/)
* [Installation Instructions](http://www.project-open.com/en/list-installers)

About OpenACS Kernel:

<p>The OpenACS &quot;kernel&quot; defines the core of the ]project-open[ data-model. The package does not define any graphical user interface. <p>Object types defined: <ul><li><a href="/en/object-type-acs-object">Object</a>: The super-class of all ]project-open[ business objects.<li><a href="/en/object-type-acs-privilege">Privilege</a>: Privileges are part of the <a href="http://openacs.org/doc/permissions-tediously-explained.html">permission system<span class="external"> </span></a>. A privilege represents a permission to perform a specific transaction on an <a href="/en/object-type-acs-object">object</a>.<li><a href="/en/object-type-user">User</a>: The super-type for all types of ]po[ users including <a href="/en/object-type-person">persons</a>, <a href="/en/object-type-party">parties</a>, <a href="/en/object-type-im-employee">employees</a> and <a href="/en/object-type-im-freelancer">freelancers</a>.<li><a href="/en/object-type-acs-rel">Relationships</a>: A super-type of links between <a href="/en/object-type-acs-object">objects</a>.<li><a href="/en/object-type-site-node">Site Nodes</a>: The nodes that make up the dynamic Site Map.<li><a href="/en/object-type-group">Groups</a>: Groups of users including sub-groups. </ul><p>

# Online Reference Documentation

## Procedure Files

<table cellpadding="0" cellspacing="0"></table>

## Procedures

<table cellpadding="0" cellspacing="0"></table>

## SQL Files

<table cellpadding="0" cellspacing="0"><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/acs-create-2.sql&amp;version_id=10">sql/postgresql/acs-create-2.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/acs-create.sql&amp;version_id=10">sql/postgresql/acs-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/acs-drop.sql&amp;version_id=10">sql/postgresql/acs-drop.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/acs-install.sql&amp;version_id=10">sql/postgresql/acs-install.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/acs-kernel-create.sql&amp;version_id=10">sql/postgresql/acs-kernel-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/acs-kernel-drop.sql&amp;version_id=10">sql/postgresql/acs-kernel-drop.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/acs-logs-create.sql&amp;version_id=10">sql/postgresql/acs-logs-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/acs-logs-drop.sql&amp;version_id=10">sql/postgresql/acs-logs-drop.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/acs-metadata-create.sql&amp;version_id=10">sql/postgresql/acs-metadata-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/acs-metadata-drop.sql&amp;version_id=10">sql/postgresql/acs-metadata-drop.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/acs-object-util-remove.sql&amp;version_id=10">sql/postgresql/acs-object-util-remove.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/acs-object-util.sql&amp;version_id=10">sql/postgresql/acs-object-util.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/acs-objects-create.sql&amp;version_id=10">sql/postgresql/acs-objects-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/acs-objects-drop.sql&amp;version_id=10">sql/postgresql/acs-objects-drop.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/acs-permissions-create.sql&amp;version_id=10">sql/postgresql/acs-permissions-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/acs-permissions-drop.sql&amp;version_id=10">sql/postgresql/acs-permissions-drop.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/acs-relationships-create.sql&amp;version_id=10">sql/postgresql/acs-relationships-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/acs-relationships-drop.sql&amp;version_id=10">sql/postgresql/acs-relationships-drop.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/apm-create.sql&amp;version_id=10">sql/postgresql/apm-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/apm-drop.sql&amp;version_id=10">sql/postgresql/apm-drop.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/authentication-create.sql&amp;version_id=10">sql/postgresql/authentication-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/authentication-drop.sql&amp;version_id=10">sql/postgresql/authentication-drop.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/authentication-package-create.sql&amp;version_id=10">sql/postgresql/authentication-package-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/authentication-package-drop.sql&amp;version_id=10">sql/postgresql/authentication-package-drop.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/community-core-create.sql&amp;version_id=10">sql/postgresql/community-core-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/community-core-drop.sql&amp;version_id=10">sql/postgresql/community-core-drop.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/groups-body-create.sql&amp;version_id=10">sql/postgresql/groups-body-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/groups-create.sql&amp;version_id=10">sql/postgresql/groups-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/groups-drop.sql&amp;version_id=10">sql/postgresql/groups-drop.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/journal-create.sql&amp;version_id=10">sql/postgresql/journal-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/journal-drop.sql&amp;version_id=10">sql/postgresql/journal-drop.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/load-data1.sql&amp;version_id=10">sql/postgresql/load-data1.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/lob.sql&amp;version_id=10">sql/postgresql/lob.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/postgresql.sql&amp;version_id=10">sql/postgresql/postgresql.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/rel-constraints-body-create.sql&amp;version_id=10">sql/postgresql/rel-constraints-body-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/rel-constraints-create.sql&amp;version_id=10">sql/postgresql/rel-constraints-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/rel-constraints-drop.sql&amp;version_id=10">sql/postgresql/rel-constraints-drop.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/rel-segments-body-create.sql&amp;version_id=10">sql/postgresql/rel-segments-body-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/rel-segments-create.sql&amp;version_id=10">sql/postgresql/rel-segments-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/rel-segments-drop.sql&amp;version_id=10">sql/postgresql/rel-segments-drop.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/security-create.sql&amp;version_id=10">sql/postgresql/security-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/security-drop.sql&amp;version_id=10">sql/postgresql/security-drop.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/site-node-object-map-create.sql&amp;version_id=10">sql/postgresql/site-node-object-map-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/site-node-object-map-drop.sql&amp;version_id=10">sql/postgresql/site-node-object-map-drop.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/site-nodes-create.sql&amp;version_id=10">sql/postgresql/site-nodes-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/site-nodes-drop.sql&amp;version_id=10">sql/postgresql/site-nodes-drop.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/test-harness/acs-core.sql&amp;version_id=10">sql/postgresql/test-harness/acs-core.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/test-harness/acs-permissions.sql&amp;version_id=10">sql/postgresql/test-harness/acs-permissions.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/test/acs-objects-test.sql&amp;version_id=10">sql/postgresql/test/acs-objects-test.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/test/groups-test.sql&amp;version_id=10">sql/postgresql/test/groups-test.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/test/rel-constraints-test.sql&amp;version_id=10">sql/postgresql/test/rel-constraints-test.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/test/rel-segments-test-types-create.sql&amp;version_id=10">sql/postgresql/test/rel-segments-test-types-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/test/rel-segments-test-types-drop.sql&amp;version_id=10">sql/postgresql/test/rel-segments-test-types-drop.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/test/rel-segments-test.sql&amp;version_id=10">sql/postgresql/test/rel-segments-test.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-4.2-4.5.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-4.2-4.5.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-4.5-4.5.1.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-4.5-4.5.1.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-4.5.1-4.5.2.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-4.5.1-4.5.2.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-4.5.1-4.6.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-4.5.1-4.6.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-4.6-4.6.1.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-4.6-4.6.1.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-4.6-4.6.1d1.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-4.6-4.6.1d1.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-4.6.1-4.6.2.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-4.6.1-4.6.2.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-4.6.1-4.7d.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-4.6.1-4.7d.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-4.6.1d1-4.6.1d2.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-4.6.1d1-4.6.1d2.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-4.6.2-4.6.3.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-4.6.2-4.6.3.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-4.6.3-4.6.4.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-4.6.3-4.6.4.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-4.6.4-4.6.5.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-4.6.4-4.6.5.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-4.6.5-4.6.6.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-4.6.5-4.6.6.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-4.7.2d-5.0d.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-4.7.2d-5.0d.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-4.7d-4.7.2d.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-4.7d-4.7.2d.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.0.0a1-5.0.0a2.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.0.0a1-5.0.0a2.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.0.0a4-5.0.0a5.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.0.0a4-5.0.0a5.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.0.0b1-5.0.0b2.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.0.0b1-5.0.0b2.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.0.0b2-5.0.0b3.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.0.0b2-5.0.0b3.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.0.0b3-5.0.0b4.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.0.0b3-5.0.0b4.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.0.0b4-5.0.0b5.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.0.0b4-5.0.0b5.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.0d-5.0d2.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.0d-5.0d2.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.0d11-5.0d12.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.0d11-5.0d12.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.0d2-5.0d3.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.0d2-5.0d3.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.0d6-5.0d7.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.0d6-5.0d7.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.0d7-5.0d9.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.0d7-5.0d9.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.1.1d1-5.1.1d2.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.1.1d1-5.1.1d2.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.1.2d1-5.1.2d2.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.1.2d1-5.1.2d2.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.1.2d2-5.1.2d3.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.1.2d2-5.1.2d3.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.2.0b1-5.2.0b2.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.2.0b1-5.2.0b2.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.2.0b10-5.2.0b11.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.2.0b10-5.2.0b11.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.2.0b9-5.2.0b10.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.2.0b9-5.2.0b10.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.2.0d1-5.2.0d2.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.2.0d1-5.2.0d2.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.2.0d11-5.2.0d12.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.2.0d11-5.2.0d12.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.2.0d3-5.2.0d4.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.2.0d3-5.2.0d4.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.2.0d5-5.2.0d6.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.2.0d5-5.2.0d6.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.2.0d6-5.2.0d7.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.2.0d6-5.2.0d7.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.2.0d7-5.2.0d8.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.2.0d7-5.2.0d8.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.2.0d8-5.2.0d9.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.2.0d8-5.2.0d9.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.2.0d9-5.2.0d10.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.2.0d9-5.2.0d10.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.2.1d1-5.2.1d2.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.2.1d1-5.2.1d2.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.2.2-5.2.3b1.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.2.2-5.2.3b1.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.3.0b1-5.3.0b2.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.3.0b1-5.3.0b2.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.3.0d1-5.3.0d2.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.3.0d1-5.3.0d2.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.3.1b1-5.3.1b2.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.3.1b1-5.3.1b2.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.3.2d1-5.3.2d2.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.3.2d1-5.3.2d2.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.4.0d1-5.4.0d2.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.4.0d1-5.4.0d2.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.4.0d2-5.4.0d3.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.4.0d2-5.4.0d3.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.4.0d3-5.4.0d4.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.4.0d3-5.4.0d4.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.4.0d4-5.4.0d5.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.4.0d4-5.4.0d5.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.4.1-5.4.2b1.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.4.1-5.4.2b1.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.5.0d1-5.5.0d2.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.5.0d1-5.5.0d2.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.5.0d2-5.5.0d3.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.5.0d2-5.5.0d3.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.5.0d3-5.5.0d4.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.5.0d3-5.5.0d4.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.5.0d4-5.5.0d5.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.5.0d4-5.5.0d5.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.5.0d5-5.5.0d6.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.5.0d5-5.5.0d6.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.6.0b1-5.6.0b2.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.6.0b1-5.6.0b2.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.6.0b2-5.6.0b3.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.6.0b2-5.6.0b3.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.6.0d1-5.6.0d2.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.6.0d1-5.6.0d2.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.6.0d2-5.6.0d3.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.6.0d2-5.6.0d3.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.6.0d3-5.6.0d4.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.6.0d3-5.6.0d4.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.6.0d4-5.6.0d5.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.6.0d4-5.6.0d5.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.6.0d5-5.6.0d6.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.6.0d5-5.6.0d6.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.6.0d6-5.6.0d7.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.6.0d6-5.6.0d7.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.6.0d7-5.6.0d8.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.6.0d7-5.6.0d8.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.7.0d1-5.7.0d2.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.7.0d1-5.7.0d2.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.7.0d10-5.7.0d11.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.7.0d10-5.7.0d11.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.7.0d2-5.7.0d3.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.7.0d2-5.7.0d3.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.7.0d3-5.7.0d4.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.7.0d3-5.7.0d4.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.7.0d4-5.6.0d5.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.7.0d4-5.6.0d5.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.7.0d5-5.7.0d6.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.7.0d5-5.7.0d6.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.7.0d7-5.7.0d8.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.7.0d7-5.7.0d8.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.7.0d8-5.7.0d9.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.7.0d8-5.7.0d9.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.8.0d1-5.8.0d2.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.8.0d1-5.8.0d2.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.8.0d2-5.8.0d3.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.8.0d2-5.8.0d3.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.8.0d3-5.8.0d4.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.8.0d3-5.8.0d4.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.8.0d4-5.8.0d5.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.8.0d4-5.8.0d5.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.8.1-5.8.3d1.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.8.1-5.8.3d1.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.8.1a3-5.8.1a4.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.8.1a3-5.8.1a4.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.8.1a4-5.8.1a5.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.8.1a4-5.8.1a5.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.8.1a5-5.8.1a6.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.8.1a5-5.8.1a6.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.8.1d1-5.8.1d2.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.8.1d1-5.8.1d2.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.8.1d2-5.8.1d3.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.8.1d2-5.8.1d3.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.8.1d3-5.8.1d4.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.8.1d3-5.8.1d4.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.8.1d4-5.8.1d5.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.8.1d4-5.8.1d5.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.8.1d5-5.8.1d6.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.8.1d5-5.8.1d6.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.8.3d1-5.8.3d2.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.8.3d1-5.8.3d2.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.9.0d1-5.9.0d2.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.9.0d1-5.9.0d2.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.9.0d3-5.9.0d4.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.9.0d3-5.9.0d4.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.9.0d4-5.9.0d5.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.9.0d4-5.9.0d5.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.9.0d5-5.9.0d6.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.9.0d5-5.9.0d6.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.9.0d6-5.9.0d7.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.9.0d6-5.9.0d7.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/upgrade/upgrade-5.9.0d8-5.9.0d9.sql&amp;version_id=10">sql/postgresql/upgrade/upgrade-5.9.0d8-5.9.0d9.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/utilities-create.sql&amp;version_id=10">sql/postgresql/utilities-create.sql</a></b></td><td></td><td></td></tr><tr valign="top"><td><b><a href="http://www.project-open.net/api-doc/display-sql?package_key=acs-kernel&amp;url=postgresql/utilities-drop.sql&amp;version_id=10">sql/postgresql/utilities-drop.sql</a></b></td><td></td><td></td></tr></table>

## Content Pages

<table cellpadding="0" cellspacing="0"></table>

